/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/fluxcd/flagger/pkg/apis/flagger/v1beta1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// MetricTemplateLister helps list MetricTemplates.
// All objects returned here must be treated as read-only.
type MetricTemplateLister interface {
	// List lists all MetricTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.MetricTemplate, err error)
	// MetricTemplates returns an object that can list and get MetricTemplates.
	MetricTemplates(namespace string) MetricTemplateNamespaceLister
	MetricTemplateListerExpansion
}

// metricTemplateLister implements the MetricTemplateLister interface.
type metricTemplateLister struct {
	indexer cache.Indexer
}

// NewMetricTemplateLister returns a new MetricTemplateLister.
func NewMetricTemplateLister(indexer cache.Indexer) MetricTemplateLister {
	return &metricTemplateLister{indexer: indexer}
}

// List lists all MetricTemplates in the indexer.
func (s *metricTemplateLister) List(selector labels.Selector) (ret []*v1beta1.MetricTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.MetricTemplate))
	})
	return ret, err
}

// MetricTemplates returns an object that can list and get MetricTemplates.
func (s *metricTemplateLister) MetricTemplates(namespace string) MetricTemplateNamespaceLister {
	return metricTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// MetricTemplateNamespaceLister helps list and get MetricTemplates.
// All objects returned here must be treated as read-only.
type MetricTemplateNamespaceLister interface {
	// List lists all MetricTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.MetricTemplate, err error)
	// Get retrieves the MetricTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.MetricTemplate, error)
	MetricTemplateNamespaceListerExpansion
}

// metricTemplateNamespaceLister implements the MetricTemplateNamespaceLister
// interface.
type metricTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all MetricTemplates in the indexer for a given namespace.
func (s metricTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.MetricTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.MetricTemplate))
	})
	return ret, err
}

// Get retrieves the MetricTemplate from the indexer for a given namespace and name.
func (s metricTemplateNamespaceLister) Get(name string) (*v1beta1.MetricTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("metrictemplate"), name)
	}
	return obj.(*v1beta1.MetricTemplate), nil
}
